% Algorithms
% 
%   Folders:
%   <a href="matlab:helpwin 'FAESOR/algorithms/integrators'">integrators</a>       - ODE integrators for mechanical systems. 
%  
% Interpolation
%   isoparamipol1d                 - Perform isoparametric interpolation in 1D
%   isoparamipol1ddersp            - Perform isoparametric interpolation in
%                                           1D, with derivatives
%   simplex_grid_interpolation     - interpolate on a simplex grid
%   remove_bias                    - Remove linear bias from harmonic signal
%   one_sided_DFT                  - One-sided DFT
%
% Penalty enforcement of boundary conditions
%   apply_penalty_ebc              - Apply penalty essential boundary conditions.
% 
% Free-vibration in fluids
%   wet_free_vibration_bem_solver  - Free-vibration wet modes of structures
% 
% Rotation dynamics
%   cayley                         - Compute the Cayley transform.
%   dexpdot                        - Compute the time derivative of the derivative of the exponential map.
%   dexpinv                        - Compute the inverse of the derivative of the exponential map.
%   reortho                        - Re-orthogonalize an approximate rotation matrix
%   skewmat                        - Compute a skew matrix from its axial vector Theta.
%   rotmat2rotvec                  - Convert rotation matrix R to rotation vector V
%   rotmat                         - Compute rotation matrix from a rotation vector or from the associated
% 
% Visualization
%   show_field_as_arrows           - Visualize a field as arrows. 
%   isosurf_faces                  - compute tessellation of isosurfaces within a
%                                           geometric cell
%   tricontour                     - Contouring for functions defined on triangular meshes
% 
% Quadrature
%   gaussquad                      - Gaussian quadrature integration.
% 
% Convergence analysis
%   richextrapol                   - Richardson extrapolation.
