%  Draw graphic representation for all gcells.
%
% function draw(self, gv, context)
%
%
% See the function draw_mesh()
%
% As a convenience, both the displacement (u) and the rotation field (R) may be
% supplied as empty.
% In that case the displacement is initialized to be a zero field, and the
% rotation field is initialized to identities as rotations.
% 
function draw(self, gv, context)
    if (isfield(context,'rot'))
        context.R = update_rotation_field(field(struct ('name',['R'], 'dim', 9, 'data', ones(get(context.rot,'nfens'),1)*reshape(eye(3),1,9))),context.rot);
    end
    if (isempty(context.u))
        context.u=0*context.x;
    end
    if (isempty(context.R))
        context.R = update_rotation_field(field(struct ('name',['R'], 'dim', 9, 'data', ones(get(context.x,'nfens'),1)*reshape(eye(3),1,9))),0*context.x);
    end
    draw_mesh(self, gv, context);
end
