% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val={{{'N'},{'normal, vector or function handle'}};...
            {{'damping_abc'},{'damping coefficient for the ABC''s'}}};
         val = cat(1,get(self.feblock_defor_ss), val);
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'N'
                val = self.N;
            case 'damping_abc'
                val = self.damping_abc;
            otherwise
                val = get(self.feblock_defor_ss, prop_name);
        end
    end
end
