% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    geom=geometry field
% with optional fields
% facecolor = color of the faces, solid
% colorfield =field with vertex colors
% only one of the facecolor and colorfield may be supplied
%  shrink = shrink factor
%
function draw (self, gv, context)
    context.faces=[1,4,6;2,5,4;3,6,5;4,5,6];
    context.edges= [1,4,2,5,3,6,1];
    node_pc=[0,0;1,0;0,1;0.5,0;0.5,0.5;0,0.5];
    if isfield(context,'shrink')
        c=ones(size(node_pc,1),1)*(sum(node_pc)/size(node_pc,1));
        pc=c+context.shrink*(node_pc-c);
        for j=1:size(pc,1)
            context.shrunk_pc_N{j}=bfun(self,pc(j,:));
        end
    end
    draw (self.gcellset_2_manifold, gv, context);
end
