% Evaluate the basis function matrix for an 2-node beam element, 
% for the transverse displacement. The degrees of freedom are transverse
% displacement at node 1, transverse displacement at node 2, rotation at
% node 1, and rotation at node 2.
%
% function val = bfun(self,param_coords)
%
%   Call as:
%      N = bfun (g, pc)
%   where
%      g=gcell,
%      pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=1.
%
function val = bfun(self,param_coords)
    x=param_coords(1);
    val = [x*(x^2/4 - 3/4) + 1/2;
        1/2 - x*(x^2/4 - 3/4);
        x*(x*(x/4 - 1/4) - 1/4) + 1/4;
        x*(x*(x/4 + 1/4) - 1/4) - 1/4];
end

