% Create a subset of a gcell_beam3 set.
%
% function self = subset(self, l)
%
% Input:
%
%   self = a gcellset_beam3 object
%
%   l = a vector of numbers corresponding to the cells making up the
%   desired subset of cells. These can be found using the gcell_select
%   function.
%
% Output:
%
%   self - a gcellset_beam3 object made up of the desired subset of the
%   original gcellset_beam3 members
function retobj = subset(self, l)
    conn = get(self, 'conn');
    % get the unique members of the set requested 
    l = unique(l);
    % extract the appropriate information for the subset
    retobj = set(self, 'conn', conn(l, :));
    retobj.x1x2_vector = self.x1x2_vector(:, l);
    retobj.A = self.A(l);
    retobj.I1 = self.I1(l);
    retobj.I2 = self.I2(l);
    retobj.I3 = self.I3(l);
    retobj.J = self.J(l);
    retobj.dimensions = self.dimensions(l,:);
end
