% Constructor of perfectly plastic J2 Material model.
%
% function retobj = mater_ss_plastic_perf_j2_triax (varargin)
%
% Describes material that is isotropically elastic / perfectly plastic. 
% The Mises yield condition is used: hence, this is J-2 plasticity.
% Parameters:
% required fields
%     property = property object that supports isotropic material
% 
function retobj = mater_ss_plastic_perf_j2_triax (varargin)
  class_name='mater_ss_plastic_perf_j2_triax';
  if (nargin == 0)
        parent=mater_defor;
        self.property = [];
        retobj = class(self,class_name, parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters =varargin{1};
            parent=mater_defor(Parameters);
            self.property = Parameters.property;
            retobj = class(self,class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
