% Get some data from a material state.
%   Call as:
%      val = matstate_get(m, ms), or
%      val = matstate_get(m, ms, prop_name)
%   where
%      m         - material
%      ms        - material state
%      prop_name - name of supported attribute
%
%   The first form returns the list of property names as a string, 
%   the second form returns the value of the named property.
%
function val = matstate_get(self, ms, varargin)
  if (nargin == 2)
    val = [ char('equiv_pl_def - equivalent plastic deformation, scalar', ...
                 'eps_p - plastic strain, array [6,1]') ];
    return;
  else
    prop_name=varargin{1};
    switch prop_name
      case 'equiv_pl_def'
        val = ms.equiv_pl_def;
      case 'eps_p'
        val = ms.eps_p;
      otherwise
        error(['Unknown property ''' prop_name '''!']);
    end
  end
  
