% Constructor of a dense system matrix.
%
% function self = dense_sysmat (varargin)
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>.
%
% Parameters: none
% 
% The matrix is empty to begin with. It needs to be assembled from finite
% element contributions. The proper sequence is
% K = dense_sysmat;
% K = start (K, get(theta, 'neqns'));
% K = assemble (K, conductivity(febLayer1, geom, theta));
% or, shorter version,
% K = start (dense_sysmat, get(theta, 'neqns'));
% K = assemble (K, conductivity(febLayer1, geom, theta));
%
function self = dense_sysmat (varargin)
    class_name='dense_sysmat';
    parent = sysmat;
    if (nargin == 0)
        self.mat = [];
        self = class(self,class_name,parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            self = arg;
            return;
        else
            error ('Illegal call!');
            return;
        end
    else
        error('Illegal arguments!');
    end
end


