% 12/30/2010
% -- fixed an error in H8_to_H64
% -- added linear box buckling examples with reference values from ABAQUS
%
% 01/13/2011
% -- fixed missing attributes in system matrix classes get() method
% -- completed and corrected documentation for system vector and matrix
% -- completed and corrected documentation for classes up to feblock
% -- completed and corrected documentation for algorithms, documents,
% and utilities
% -- completed and corrected documentation for meshing
%
% 01/14/2011
% -- completed documentation for examples (acoustics,
% electrical thermomechanical, heat diffusion,
% miscellaneous, taut wire, instability, stress)
% -- Fixed an incorrect implementation of in_parametric
% for the triangles and tetrahedra.
% -- completed and corrected documentation for gcellset,
% integration_rule, graphic_viewer, fenode_to_gcell_map
%
% 01/21/2011
% -- imported hyperelastic finite element block and hyper elastic neo-Hookean
% material classes from Sofea legacy code; not all examples have been ported though as yet
%
% 01/23/2011
% -- Error in the transformation of arrows in draw_arrow: parallel vectors
% in cross product. Corrected.
%
% 01/26/2011
% -- Fixed signature and description of H8_hexahedron()
% -- Enhanced the numbering of equations to allow for node linkages; see
% the method numbereqns of the field class.
% -- Concatenation of geometric cells corrected so that the label attribute
% is concatenated correctly.
% -- Setting of essential boundary conditions in set_ebc. The arguments
% may now be supplied as scalars and expanded into arrays as needed.
% -- update_box documentation updated.
%
% 02/01/2011
% -- Trying to plot a geometric cell with empty conductivity resulted in
% Matlab crash (R2009b and R2010a) because the Java graphics framework
% couldn't handle empty faces. This is now treated in FAESOR.
%
% 02/08/2011
% -- Added an implementation of a linear model of a beam, and implementation
% of examples for the corotational nonlinear beam model.
%
% 02/16/2011
% -- Implemented acoustic-structural coupling matrix.
% -- Implemented the ability of the graphic viewer to draw into given axes.
% -- Updated feblock documentation for acoustics, heat diffusion, electrostatics.
%
% 02/22/2011
% -- Fixed broken sizing of graphics axes for 2-D plots.
%
% 03/13/2011
% -- Implemented plotting of level curves. (At this point for T3,T6.)
% -- The interfaces to the methods of the corotational beam were redesigned
% to be more consistent with the theoretical formulation.
%
% 03/17/2011
% -- Implemented linewidth in graphics viewer.
% -- Implemented plotting of level curves for Q4.
%
% 03/22/2011
% -- Fixed incorrect data aspect ratio in 2-D plots.
% -- Fixed invalid reference to interpreter in draw_colorbar.
% -- Tested with Matlab R2009b, R2011a. 
% -- Updated nonlinear heat conduction examples.
%
% 03/23/2011
% -- Updated and completed documentation of the corotational beam (classes
% and examples). 
%
% 03/26/2011
% -- Enhanced the operation of view3d (speeding up and slowing down of
% rotation). 
%
% 03/27/2011
% -- Corrected the slice() method of the field class: all the attributes
% are now being sliced not just the values. 
%
% 04/01/2011
% -- Added documentation for beam meshing functions. 
% -- Revised documentation of beam examples 
%
% 04/04/2011
% -- Extrusion functions (L2_extrude,Q4_extrude) were corrected to exclude 
% extraneous nodes.
% -- Added fuse_nodes function. 
% -- Added merge_n_meshes function to merge multiple meshes.
%
% 04/16/2011
% -- Enhanced the graphic_viewer view manipulation by completely rewriting the
% rotate() method. 
% -- Added arch-buckling 3-D solid example. 
% -- Redesigned physical_units() function. 
%
% 04/17/2011
% -- gcell_select with flooding was found to have a bug. The selection
% algorithm was redesigned, for the moment without the option to select
%     based on distance from the start node. 
%
% 04/20/2011
% -- Speeded up computation of nz_ebc loads (typically by an order of
% magnitude). 
%
% 04/22/2011
% -- Fixed constructor of tet_rule. 
%
% 05/04/2011
% -- ipdm: Inter-Point Distance Matrix By  John D'Errico added.
% -- gcell_select enhanced with the option to search for the cell nearest
% to a given location (nearestto). Courtesy of Richard Crozier.
% -- subset() For gcellset_beam3 added to properly distribute cross section
% properties. 
%
% 05/07/2011
% -- Any call to the method set_ebc() of field invalidates the current
% equation numbering. The logic of set_ebc() was modified to  erase any
% current numbering of equations. 
% 
% 05/13/11
% -- Revised physical_units(). 
% -- Revised graphic_viewer() methods. Added draw_xlabel, ..., draw_zlabel.
%    Added  draw_box() method.
% -- Corrected subset() method of class gcellset_beam3.
% -- Corrected a number of meshing functions (rotate_mesh, merge_nodes,
% merge_n_meshes). 
%
% 06/01/2011
% -- Corrected a coefficient in the bulk-shear split of the elastic moduli
% (tangent_moduli_bulk_shear). 
% -- targe2_mesher enhancement: If the mesher fails (for instance because the input was
% inconsistent or just plain wrong), the function reports an error message
% and the input is plotted in figure to help the user in debugging the
% input.
%
% 06/03/2011
% -- Speeded up some methods (scatter_sysvec, in particular). Credits Richard Crozier.
%
% 06/23/2011
% -- Update to the subset and get methods of the gcellset_beam3 class
%      to correctly handle access to all attributes.
% -- Additional methods for the @feblock_defor_ss_corot_beam class.
% -- Redesign of the @feblock_defor_tie_line class. 
% -- cleanup of image_meshing examples. 
% 
% 06/30/2011
% -- Updated the vibration-in-fluids example (including the boundary element solver).
% 
% 07/13/2011
% -- Updates and fixes to the graphic_viewer class (draw_polyline, draw_text, rotate
% methods). Fix of clear() and a reset() methods.
% -- The class feblock_defor_ground now supports
% translational and rotational springs and dampers.