% function Armero
E =40e9;
nu=0.45;
stabfact=  0.2*E/2;
%     E/3/( 1-2*nu)
rho=8.6e3;
nus = [(1:100)*0+nu];
vini =0.23e3;
%
dimA= 5;
dimB= 1;
tol= 0.001;

tau =0.51;
maxit = 30;
tup = 1;
dt =0.5e-3;
nincr =round(tup/dt);

graphics =false;
cam = [  -81.9855   82.4325   65.1450   -1.7698    2.5016    1.4936         0         0    1.0000    2.3047];
scale=1;
nas = 1;
nbs = 3;
nLs = 5;
circumlt=2;


Report =@(x) (disp(x) );
%     Report =@(x) ([]);


na = 3;
nb = 2;
nL = 19;
%


eix=1;
clear eltyd


eltyd(eix).label ='H8';
eltyd(eix).mf =@h8Mesh;
eltyd(eix).blf =@feblock_defor_nonlinear;
eltyd(eix).integration_rule= gauss_rule (3,2);
eltyd(eix).line_integration_rule=gauss_rule (1,2);
eltyd(eix).stabfact =stabfact;
eltyd(eix).styl='rx-.';
eix=eix+1;

%    eltyd(eix).label ='NICE-T4';
%    eltyd(eix).mf =@t4Mesh;
%    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%    eltyd(eix).integration_rule= simplex_nq_rule (3);
%    eltyd(eix).line_integration_rule=tri_rule(1);
%    eltyd(eix).stabfact =stabfact;
%    eltyd(eix).styl='m^-';
%    eix=eix+1;

%     eltyd(eix).label ='NICE-H8';
%     eltyd(eix).mf =@h8Mesh;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',1));
%     eltyd(eix).stabfact =stabfact;
%     eltyd(eix).styl='md-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-T4d';
%     eltyd(eix).mf =@t4cyld;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).stabfact =stabfact/4;
%     eltyd(eix).styl='mv-';
%     eix=eix+1;

%     eltyd(eix).label ='H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='ks-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8cylH64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;


for eix = 1:length(eltyd)

    % Mesh
    [fens,gcells]=Armero1_mesh;

    prop = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
    mater = mater_defor_neohook(struct('property',prop));
    % Finite element block
    feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
        'integration_rule',eltyd(eix).integration_rule));

    options =struct ('distance', 1.6*dimB,'from',[0,0,0]);
    %options =struct ('box', [-0.9,0.9,-0.9,0.9,1,-1],'inflate',0.1);
    mcl=gcell_select(fens,gcells,options) ;
    mgcells=gcells(mcl);
    gmcl=[gcell_select(fens,mgcells,struct('box',[-0.92,0.92,-0.92,0.92,1,-1],'inflate',0.1))];

    options =struct ('box', [-dimA,dimA,-dimB,dimB,1,-1],'inflate',0.1);
    icl=gcell_select(fens,gcells,options) ;
    igcells=gcells(setdiff(icl,mcl));
    gicl=[gcell_select(fens,igcells,struct('box',[-dimA,dimA,-dimB,dimB,1,-1],'inflate',1.1))];
    %     mesh{1}=fens;
    %     mesh{2}=gcells;
    %     drawmesh(mesh,'facecolor','black','shrink', 0.9); view (2); pause;return

    propa = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
    mata = mater_defor_neohook(struct('property',propa));
    feba = eltyd(eix).blf (struct ('mater',mata,...
        'gcells',gcells(setdiff((1:length(gcells)),mcl)),...
        'integration_rule',eltyd(eix).integration_rule));

    propc = property_linel_iso (struct('E',100*E,'nu',nu,'rho',rho));
    matc = mater_defor_neohook(struct('property',propc));
    febc = eltyd(eix).blf (struct ('mater',matc, 'gcells',mgcells,...
        'integration_rule',eltyd(eix).integration_rule));
    %
    %    function n= normal(x,tangent)
    %        n= skewmat(tangent(:,1))*tangent(:,2);
    %        n=n/norm(n);
    %    end
    %    abcbdry_gcells = mesh_bdry(gcells(icl), struct('other_dimension', 1));
    %    febabcbdry = feblock_defor_ss_damped(struct('mater',matw, 'gcells',abcbdry_gcells,...
    %        'integration_rule',gauss_rule (2, 1),'damping_abc',rhow*c,'N',@normal));

    %          mesh{1}=fens;
    %             mesh{2}=abcbdry_gcells;
    %             drawmesh(mesh,'facecolor','red','shrink',0.9,'nodes'); view (2); pause;
    %


    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
    % Define the displacement field
    u   = 0*geom; % zero out
    % Apply EBC's
    ebc_fenids=fenode_select (fens,struct('box',[-dimA,dimA,-dimB,dimB,1,-1],'inflate',10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+3;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);

    ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,1,-1],'inflate',tol));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=[];
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);

    % Number equations
    u   = numbereqns (u);

    if graphics, gv=graphic_viewer; end

    if graphics,
        gv=reset(clear(gv,[]),[]);
        %                     camset(gv,cam);
        view(2);
        draw(febc,gv, struct ('x', geom,'u',u, 'facecolor','red'));
        draw(feba,gv, struct ('x', geom,'u',u, 'facecolor','Yellow'));
        %                 headlight(gv);
        pause(0.5);
        %                     cam =camget(gv);
    end

    % Now comes the nonlinear solution
    tup = 1;
    u = u*0; % zero out the displacement
    v = u*0; % zero out the Velocity
    Es=[]; Ks=[];
    us = {};
    xyz = gather(geom,(1:length(fens)),'values','noreshape');
    vxyz = gather(v,(1:length(fens)),'values','noreshape');
    vxyz =xyz*skewmat( [0, 0, vini]);
    v= scatter (v,(1:length(fens)),vxyz);
    utol = 1e-13*get(u, 'neqns');
    tipu = [];

    K = start (sparse_altassem_sysmat, get(u, 'neqns'));
    %K_geo = start (sparse_altassem_sysmat, get(u, 'neqns'));
    %K_stab = start (sparse_altassem_sysmat, get(u, 'neqns'));
    M = start (sparse_altassem_sysmat, get(u, 'neqns'));
    Mems=mass(feb, geom, u);% Constant mass matrix
    M =assemble (M,Mems);
    for  j = 1:length(Mems)
        Mems(j) =set(Mems(j),'mat',get(Mems(j),'mat')/((tau*dt)^2));
    end

%     figure;
    t=0; % time=load magnitude
    incr=1;
    while (incr <= nincr)
        Report(['Increment ' num2str(incr) ]); % pause
        % Initialization
        umid = u+(tau*dt)*v; % guess
        du = 0*u; % this will hold displacement increment
        umid = apply_ebc(umid);
        du = apply_ebc(du);
        F0 = start (sysvec, get(u, 'neqns'));
        F0 = assemble (F0, inertial_force(feb, geom, u+(tau*dt)*v, Mems));

        iter=1;
        %                 if graphics,
        %                     gv=reset(clear(gv,[]),[]);
        %                     camset(gv,cam);
        %                     draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','cyan'));
        %                     draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow','alpha', 0.2));
        %                     %                 headlight(gv);
        %                     cam =camget(gv);
        %                 end
        while 1
            feb1=feb;
            [febc,evsc] = restoring_force(febc,geom,umid,u);       % Internal forces
            [feba,evsa] = restoring_force(feba,geom,umid,u);
            evs=cat(2,evsc,evsa);
            [febc,evsc] = restoring_force_stab(febc,geom,umid,u,eltyd(eix).stabfact);       % Internal forces
            [feba,evsa] = restoring_force_stab(feba,geom,umid,u,eltyd(eix).stabfact);
            evs=cat(2,evs,evsc,evsa);
            Ff = start (sysvec, get(u, 'neqns'));
            Ff = assemble (Ff, evs);
            F = F0;
            F = assemble (F, inertial_force(feb, geom, (-1)*umid, Mems));
            F = assemble (F, evs);
            ems=cat(2,stiffness(febc, geom, umid,u),stiffness(feba, geom, umid,u),...
                stiffness_geo(febc, geom, umid,u),stiffness_geo(feba, geom, umid,u),...
                stiffness_stab(febc, geom, umid,u,eltyd(eix).stabfact),stiffness_stab(feba, geom, umid,u,eltyd(eix).stabfact), ...
                Mems);
            K =assemble (K,ems);
            K = external_decomposition (K,  []);
            du = scatter_sysvec(du, K\F); % Displacement increment
            %                 max(abs(get(F,'vec')))
            umid = umid + du;   % increment displacement
            K = reinitialize (K);
            %                     if graphics,
            %                         draw(feb,gv, struct ('x', geom,'u',umid, 'facecolor','none'));
            %                         camset (gv,cam); pause(0.5); cam =camget(gv);
            %                         drawnow
            %                     end
            Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
            if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
            if (iter >maxit)% bailout for failed convergence
                error( [' Possible failed convergence']);
            end
            iter=iter+1;
        end
        amid=scatter_sysvec(0*du, M\Ff);
        vmid=v + (tau*dt)*amid;
        E = defor_energy(febc,geom,umid,u)+defor_energy(feba,geom,umid,u);   Es=[Es,E];
        Vv=gather_sysvec(vmid);
        MVv =get(assemble (start (sysvec, get(u,'neqns')),inertial_force(feb, geom, vmid, Mems)),'vec');
        Kin =(Vv'*MVv)/2;
        Kin = Kin*((tau*dt)^2); Ks=[Ks,Kin];
        Energy =Es + Ks;
        plot(Energy); hold on
        plot(Es,'r-')
        plot(Ks,'g-')
        drawnow

        v1=v +dt*amid;
        u1 =u+dt*v+tau*(dt^2)*amid;
        u = u1;       % update + the displacement
        v = v1;       % update the displacement

        Report(['    Converged for t=' num2str(t)]); % pause
        us {end +1} = u1;
        %                     norm(a)
        %             utip=gather(u,cncl,'values','noreshape');
        %             tipu(end +1) = utip(1);
        %             plot (tipu); pause(0.01);

        if graphics && (mod(incr,10)==0)
            gv=reset(clear(gv,[]),[]);
            cmap = jet(16);
            Cauchy = [];
            for j=1:6
                fld = field_from_integration_points(feb, geom, u1, [], 'Cauchy',j);
                nvals=get(fld,'values');%min(nvals),max(nvals)
                Cauchy = [Cauchy,nvals];
            end
            nvals =sqrt(( (Cauchy(:,1)-Cauchy(:,2)).^2+...
                (Cauchy(:,3)-Cauchy(:,2)).^2 +...
                (Cauchy(:,1)-Cauchy(:,3)).^2 +...
                6*(Cauchy(:,4).^2+Cauchy(:,5).^2 +Cauchy(:,6).^2))/2)/1e9;% in GPa
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feba,gv, struct ('x', geom, 'u', u,'colorfield',colorfield, 'shrink',1.0));
            draw(feba,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1.0));
            % draw(efeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','red', 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.815 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','von Mises');
            draw(febc,gv, struct ('x', geom,'u',u, 'facecolor','white'));
            view(2);
            drawnow;
        end

        t = t + dt;
        incr = incr + 1;
    end
    %                if graphics,
    %             gv=reset(clear(gv,[]),[]);camset (gv,cam);
    %clear(gv,[]);
    %                   draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
    %                   draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
    %                   camset (gv,cam);
    %               end
    %         camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
    clear K
    save ([mfilename '-nc' num2str(nc) '-nt' num2str(nt) '-' eltyd(eix).label])

end
