
% Initialization
u1 = u; % guess
du = 0*u; % this will hold displacement increment
u1 = apply_ebc(u1);
du = apply_ebc(du);
a1 = -(1/Newmarkb/dt)*v -(1/2-Newmarkb)/Newmarkb*a;
v1 = v + dt*((1-Newmarkg)*a + Newmarkg*a1);
F0 = start (sysvec, get(u, 'neqns'));
ap =-(1/Newmarkb/dt^2)*u -(1/Newmarkb/dt)*v -((1/2-Newmarkb)/Newmarkb)*a;
F0 = assemble (F0, inertial_force(feb, geom, (-Newmarkb*dt^2)*ap, Mems));

E = defor_energy(febc,geom,u1,u)+defor_energy(feba,geom,u1,u);   Es=[Es,E];
Vv=gather_sysvec(v);
MVv =get(assemble (start (sysvec, get(u,'neqns')),inertial_force(feb, geom, v, Mems)),'vec');
Kin =(Vv'*MVv)/2;
Kin = Kin*(Newmarkb*dt^2); Ks=[Ks,Kin];
Energy =Es + Ks;
plot(Energy); hold on
plot(Es,'r-')
plot(Ks,'g-')
drawnow

iter=1;
while 1
    feb1=feb;
    F = F0;
    [febc,evsc] = restoring_force(febc,geom,u1,u);       % Internal forces
    [feba,evsa] = restoring_force(feba,geom,u1,u);
    evs=cat(2,evsc,evsa);
    F = assemble (F, evs);
    [febstab,evsc] = restoring_force_stab(febc,geom,u1,u,eltyd(eix).stabfact);       % Internal forces
    [febstab,evsa] = restoring_force_stab(feba,geom,u1,u,eltyd(eix).stabfact);
    evs=cat(2,evsc,evsa);
    F = assemble (F, evs);
    F = assemble (F, inertial_force(feb, geom, (-1)*u1, Mems));

    ems=cat(2,stiffness(febc, geom, u1,u),stiffness(feba, geom, u1,u),...
        stiffness_geo(febc, geom, u1,u),stiffness_geo(feba, geom, u1,u),...
        stiffness_stab(febc, geom, u1,u,eltyd(eix).stabfact),stiffness_stab(feba, geom, u1,u,eltyd(eix).stabfact), ...
        Mems);
    K =assemble (K,ems);
    K = external_decomposition (K,  []);
    du = scatter_sysvec(du, K\F); % Displacement increment
    %                 max(abs(get(F,'vec')))
    u1 = u1 + du;   % increment displacement
    v1 = v1 + (Newmarkg/Newmarkb/dt)*du;
    a1 = a1 + (1/Newmarkb/dt^2)*du;
    K = reinitialize (K);
    Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
    if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
    if (iter >maxit)% bailout for failed convergence
        error( [' Possible failed convergence']);
    end
    iter=iter+1;
end
[feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
u = u1;       % update the displacement
v = v1;       % update the displacement
a = a1;
