function tissue_block
    stabfact=0.5;
    smult=0;
    E=0.5;
    rho=1e-9;
    graphics=~~true;
    doeig=true;
    anim = ~true;
    W=100;
    H=60;
    Magnitudescale = 200;
        
    for n=[20]

        es=(4);

        mines = [];
        maxes = [];
        for e=es
            nu=1/2-10^(-e);
            
%            [eigvals]=doitt(n,smult,E,nu,rho,stabfact, @block2d,@feblock_defor_ss_sri,gauss_rule(2, [1,2]))      
             [eigvals]=doitt(n,smult,E,nu,rho,stabfact, @block2d,@feblock_defor_ss_nicer,tensprod_nq_rule(2))
%             [eigvals]=doitt(n,smult,E,nu,rho,stabfact, @t3block2d,@feblock_defor_ss_nice,simplex_nq_rule(2))
%             [eigvals]=doitt(n,smult,E,nu,rho,stabfact, @t3block2d,@feblock_defor_ss_simplex_avg_b,tri_rule(1))
            mines=[mines,min(eigvals)];
            maxes=[maxes,max(eigvals)];
            spectplot(eigvals,'g','o','-.',3); hold on; figure (gcf); pause (1)
        end
        %     loglog(10.^es,mines,'bo-.','lineWIDTH', 1); hold on; figure (gcf); pause (1)
        %     loglog(10.^es,maxes,'bo-.','lineWIDTH', 1); hold on; figure (gcf); pause (1)


    end

    function [eigvals]=doitt(n,smult,E,nu,rho,stabfact, mf,febf,integration_rule)
        disp(['Natural modes: ' func2str(febf)]);
        % Parameters:
        
        % Mesh
        hs=[];
        se=[];
        magn=-5000000/n;
        h= max(W/n,H/n);
        [fens,gcells] = mf(W,H, n, n, 1.0);
        %     [fens,gcells] = targe2_mesh_gen({['curve 1 line ' num2str(0) ' ' num2str(0) ' ' num2str(W) ' ' num2str(0)],...
        %         ['curve 2 line ' num2str(W) ' ' num2str(0) ' ' num2str(W) ' ' num2str(H)],...
        %         ['curve 3 line ' num2str(W) ' ' num2str(H) ' ' num2str(W/2) ' ' num2str(H)],...
        %         ['curve 4 line ' num2str(W/2) ' ' num2str(H) ' ' num2str(0) ' ' num2str(H)],...
        %         ['curve 5 line ' num2str(0) ' ' num2str(H) ' ' num2str(0) ' ' num2str(0)],...
        %         'subregion 1  property 1 boundary 1 2 3 4 5',...
        %         ['m-ctl-point constant ' num2str(h)],...
        %         }, 1.0);
        dxy=min(W,H)/n/100;
        sxy=smult*dxy;
        rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
        xy=get(fens,'xyz');
        for i=1:length(fens)
            if (xy(i,1)>dxy) & (xy(i,2)>dxy) & (xy(i,1)<W-dxy) & (xy(i,2)<H-dxy)
                xy(i,:)=[xy(i,1)+(2*rand(1)-1)/2*sxy,xy(i,2)+(2*rand(1)-1)/2*sxy];
            end
        end
        fens=set(fens,'xyz',xy);
        %     mesh{1}=fens;
        %     mesh{2}=gcells;
        %     drawmesh(mesh); pause
        % Material And finite element block
        propm = property_linel_iso(struct('E',E,'nu', nu));
        mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
        feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule,...
            'stabfact',stabfact));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,W,0, 0],'inflate',H/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=2*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,W,H,H],'inflate',H/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=2*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,H],'inflate',H/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=1*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[W,W,0,H],'inflate',H/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=1*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        K = finish (K);

        M = start (sparse_sysmat, get(u, 'neqns'));
        ems = mass(feb, geom, u);
        M = assemble (M, ems);
        M = finish (M);

        %
        neigvs = 20;
        [modes,Omega]=eigs(get(K,'mat'),get(M,'mat'),neigvs,'SM');
        Os=abs(real (diag(Omega)));
        [b,ix]=sort(Os,'ascend');
        eigvals =abs(real(Os(ix)));

        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ([]));
            %         for i=1:length(fens)
            %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
            %         end
            if doeig
                %% Solve the eigenvibration problem
                %% Display the first few eigenvibration modes
                scale=1/100;
                w=clone(u,'w'); % make a copy of u
                cmap = gray;
                for i=1:neigvs
                    %                 disp(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(i,i)) ]);
                    w = scatter_sysvec(w, real(modes(:,ix(i))));
                    % display the volumetric deformation
                    fld = field_from_integration_points(feb, geom, w, [], 'vol_strain', 1);
                    nvals=get(fld,'values');%min(nvals),max(nvals)
                    % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
                    %                 nvalsrange=[min(nvals),max(nvals)];
                    nvalsrange=[-0.1,0.1];
                    dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
                    colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                    %
                    wv = get(w,'values');
                    wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                    dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                    colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                    %
                    gv=reset (clear (gv),struct ('limits', [-1/40*W 41/40*W -1/40*H 41/40*H]));
                    set(gca,'Position',[0 -0.1 1 1]);
                    font='Times';fsize= 30;
                    set(gca,'FontSize',fsize);
                    set(gca,'FontName',font)
                    l=get(gca,'xlabel');
                    set (l,'FontSize',fsize);
                    set(l,'FontName',font)
                    l=get(gca,'ylabel');
                    set (l,'FontSize',fsize);
                    set(l,'FontName',font)
                    draw(feb,gv, struct ('x', geom, 'u', +scale*w,'colorfield',colorfield, 'shrink',0.99));
                    %                 colormap(cmap);
                    %                 cbh=colorbar;
                    %                 set(cbh,...
                    %                     'Position',[0.8 0.15 0.05 0.7],...
                    %                     'YLim',[0,1],...
                    %                     'YTick',[0,1],...
                    %                     'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                    %                 set(get(cbh,'XLabel'),'String','Volumetric strain');
                    title(['Mode ' num2str(i) ': ' num2str(Omega(ix(i),ix(i))) ]);
                    view (2); pause(2)
                    % save an image
                    s =func2str(febf);
                    name = [mfilename '_n' num2str(n) '_m' num2str(i) '_nu9999' s(22:end)]
                    %             name = [mfilename '_n' num2str(n) '_m' num2str(i) '_nu9999' s(22:end) '_unstructured']
%                     saveas(gcf,[name '.fig'],'fig');
                                saveas(gcf,[name '.png']);
%                                 saveas(gcf,[name '.eps'],'eps2c');
                    %
                    if anim
                        wv = get(w,'values');
                        wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                        dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                        colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                        for scale=Magnitudescale*sin((0:1:42)/21*2*pi)
                            clf;
                            gv=reset (gv,struct ('limits', [-1/4*W 5/4*W -1/4*H 5/4*H]));
                            %         headlight(gv);
                            draw(feb,gv, struct ('x', geom, 'u', scale*w,'colorfield',colorfield));
                            title(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(i,i)) ]);
                            pause(0.01);
                        end
                        clf;
                    end
                end
            end
        end
    end


    function spectplot(eigvals, color,marker,style, LW)
        semilogy((1:length(eigvals)),eigvals,[color,style],'lineWIDTH', LW); hold on;
        e=(1:17:length(eigvals));
        semilogy(e,eigvals(e),[color,marker],'lineWIDTH', LW);
        xlabel ('Eigenvalue number')
        ylabel ('Eigenvalue')
    end
    return;
end
