function f
    kappa= 1.08*eye(2); % Isotropic conductivity matrix
    cp = 1.0;
    Width = 1.0;
    Relax =0.95;
    maxit =19;
    dt =2/3*1.0*(4/88)^2/1.08;
    dt =0.02;
    theta =1;
    tend =2;
    graphics =~true; Style ='m-';
    scale = 0.1;
    Th =0;
    Tc =-45;
    Ti =0;
    Tm1=-0.15-0.5; Tm2 =-0.15 +0.5;
    function v=cp_function(T)
    v = interp1( [Tc,Tm1,(Tm1+Tm2)/2,Tm2,Inf],[1.0,1.0,2/(Tm2-Tm1)*70.26,1.0,1.0],T);
    end
    cp=@cp_function;
    
    [fens,gcells] = block2d(4, Width, 88,1,struct('other_dimension',1));
    prop = property_thermal_diffusion(struct('thermal_conductivity',kappa,...
        'specific_heat',cp,'source',0));
    mater=mater_diffusion(struct('property',prop));
    feb = feblock_thermal_nonlinear(struct ('mater',mater,...
        'gcells',gcells,...
        'integration_rule',tensprod_nq_rule (struct('dim',2,'order',1))));
    geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
    tempn=field(struct('name',['tempn'], 'dim', 1, 'nfens',get(geom,'nfens')));
    tempn = tempn +Ti;% initial condition
    fenids=[fenode_select(fens,struct('box',[0 0 0 Width],...
        'inflate', 0.0001))];
    prescribed=ones(length(fenids),1);
    comp=[];
    val=zeros(length(fenids),1)+Tc;%  Cold
    tempn = set_ebc(tempn, fenids, prescribed, comp, val);
    fenids=[fenode_select(fens,struct('box',[4 4 0 Width],...
        'inflate', 0.0001))];
    prescribed=ones(length(fenids),1);
    comp=[];
    val=zeros(length(fenids),1)+Th;% hot
    tempn = set_ebc(tempn, fenids, prescribed, comp, val);
    tempn = apply_ebc (tempn);
    tempn = numbereqns (tempn);
    
    gL = 0* tempn+1;% all liquidus
    

    V = start (sparse_sysmat, get(tempn, 'neqns'));
    V = assemble (V, lumped_volume(feb, geom, tempn));
    NV =get(V,'mat');
    

    K = start (sparse_sysmat, get(tempn, 'neqns'));
    K = assemble (K, conductivity(feb, geom, tempn));
    Kt =get(K,'mat');
    
    
    if (graphics)
        gv=graphic_viewer;
        gv=reset (gv,[]);
    else
        tref = [0.9016,1.0,1.55,2.0];Tref = [0.0,-3.63,-10,-14.32];
        plot(tref,Tref,'ko'); hold on
    end

    fen1id=[fenode_select(fens,struct('box',[1 1 0 0],...
        'inflate', 0.0001))];
    T1 = [];
    t= 0;
    Tn = gather_sysvec(tempn);
    gLn = gather_sysvec(gL);
    Tn1 =Tn;
    r =0*Tn;
    while t<tend % Time stepping
        disp([' Time ' num2str(t)])
        C = start (sparse_sysmat, get(tempn, 'neqns'));
        C = assemble (C, capacity(feb, geom, tempn));
        Ct =get(C,'mat');
        F = start (sysvec, get(tempn, 'neqns'));
        F = assemble (F, nz_ebc_loads_conductivity(feb, geom, tempn));
        Tn=gather_sysvec(tempn);
        Tn1 = (1/dt*Ct+theta*Kt) \ ((1/dt*Ct-(1-theta)*Kt)*Tn+get(F,'vec'));
        tempn = scatter_sysvec(tempn,Tn1);
        t=t+dt;
        if (graphics)
            gv=reset (gv,[]);
            %         T=get(tempn1,'values');
            %         XY=get(geom,'values');
            %         conn=zeros(length (gcells),3);
            %         for i=1:length (gcells)
            %             conn(i,:)= get(gcells(i),'conn');
            %         end
            %         for i=1:length (gcells)
            %             draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, 'facecolor','none','edgecolor',[0.49, 0.49, 0.49]));
            %         end
            %
            %         tricontour(XY,conn,T,15)
            %         view(2)
            T=get(tempn,'values');
            dcm=data_colormap(struct ('range',[min(T),max(T)], 'colormap',hot(9)));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, T)));
            geomT=field(struct ('name', ['geomT'], ...
                'data',[get(geom,'values'), scale*T]));
            draw(feb, gv, struct ('x',geomT, 'u',0*geomT,...
                'colorfield',colorfield, 'shrink',1));
            draw(feb, gv, struct ('x',geom, 'u',0*geom, 'facecolor','none'));
            camset(gv, [-22.5860 -20.7612 12.5869 1.8371 0.0982 -0.3898 0 0 1.0 2.7437]);
            drawnow
        else
            T1= [T1,gather(tempn,fen1id,'values')];
        plot(dt*(0:1:length(T1)-1),T1,Style,'linewidth',3)
            grid on; drawnow
        end

    end
   
end
