function f
Th =7;
Tc =-13;
Ti =Th;
Tm1=-6; Tm2 =0;
function v=cp_function(T)
    if (T<Tm1) ||  (T>Tm2)
        v  =0.05;
    else
        if (T>=Tm1)&&(T<(Tm1+Tm2)/2)
            v=(T-Tm1)/((Tm2-Tm1)/2)*2000.0;
        else
            v=(Tm2-T)/((Tm2-Tm1)/2)*2000.0;
        end
    end
end
cp=@cp_function;
% kappa=@(T)(0.09+0.004*T)*eye(2); % Isotropic conductivity matrix
kappa=0.9*eye(2); % Isotropic conductivity matrix
maxit =4;
theta =1.0;
dt =20;
tend =1000;
Tn1Tol =0.01; 
graphics = true;

[fens,gcells, groups] = targe2_mesher({...
    ['curve 1 line -48 -48 48 -48'],...
    ['curve 2 line 48 -48 48 48'],...
    ['curve 3 line 48 48 -48 48'],...
    ['curve 4 line -48 48 -48 -48'],...
    ['subregion 1  property 1 ' ...
    '   boundary 1 2 3 4 '],...
    ['m-ctl-point constant 4']
    }, 1.0);
prop = property_thermal_diffusion(struct('thermal_conductivity',kappa,...
    'specific_heat',cp,'source',0));
mater=mater_diffusion(struct('property',prop));
feb = feblock_thermal_nonlinear(struct ('mater',mater,...
    'gcells',gcells,...
    'integration_rule',tri_rule(3)));
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
tempn=field(struct('name',['tempn'], 'dim', 1, 'nfens',get(geom,'nfens')));
tempn = tempn +Ti;% initial condition
fenids=[fenode_select(fens,struct('box',[-48 48 -48 -48],...
    'inflate', 0.01))];
prescribed=ones(length(fenids),1);
comp=[];
val=zeros(length(fenids),1)+Th;% ambient temperature
tempn = set_ebc(tempn, fenids, prescribed, comp, val);
fenids=[fenode_select(fens,struct('box',[-48 48 48 48],...
    'inflate', 0.01))];
prescribed=ones(length(fenids),1);
comp=[];
val=zeros(length(fenids),1)+Tc;% hot inner surface
tempn = set_ebc(tempn, fenids, prescribed, comp, val);
tempn = apply_ebc (tempn);
tempn = numbereqns (tempn);

C = start (sparse_sysmat, get(tempn, 'neqns'));
C = assemble (C, capacity(feb, geom, tempn));

K = start (sparse_sysmat, get(tempn, 'neqns'));
K = assemble (K, conductivity(feb, geom, tempn));

if (graphics)
    gv=graphic_viewer;
    gv=reset (gv,[]);
end
    
t= 0;
while t<tend % Time stepping
    disp([' Time ' num2str(t)])
    Tn = gather_sysvec(tempn);
    tempn1 =tempn;
    pTn1= gather_sysvec(tempn1);
    for i=1:maxit
%         if (graphics)
%             gv=reset (gv,[]);
%             geomT=field(struct ('name', ['geomT'], ...
%                 'data',[get(geom,'values'), get(tempn1,'values')]));
%             draw(feb, gv, struct ('x',geomT, 'u',0*geomT, 'facecolor','none','edgecolor',0*[0.49, 0.49, 0.49]));
%             drawnow; figure(gcf);
%         end
        Ft = start (sysvec, get(tempn, 'neqns'));
        Ft = assemble (Ft, nz_ebc_loads_conductivity(feb, geom, ...
            theta*tempn1 + (1-theta)*tempn));
        Ft = assemble (Ft, nz_ebc_loads_capacity(feb, geom, ...
            (tempn1-tempn)*(1/dt)));
        Tn1=(1/dt*get(C,'mat')+get(K,'mat'))\((get(C,'mat'))*(1/dt*Tn)+get(Ft,'vec'));
        tempn1 = scatter_sysvec(tempn1, Tn1);
        nT=norm(Tn1-pTn1,Inf);
        disp(['  Max T=' num2str(max(Tn1)) ', norm(Tn1-pTn1)=' num2str(nT)]);
        if (nT<Tn1Tol)
            break;
        end
        C = start (sparse_sysmat, get(tempn1, 'neqns'));
        C = assemble (C, capacity(feb, geom, tempn1));
        pTn1 =Tn1;
    end
    t=t+dt;
    tempn =tempn1;
    if (graphics)
        gv=reset (gv,[]);
        %         T=get(tempn1,'values');
        %         XY=get(geom,'values');
        %         conn=zeros(length (gcells),3);
        %         for i=1:length (gcells)
        %             conn(i,:)= get(gcells(i),'conn');
        %         end
        %         for i=1:length (gcells)
        %             draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, 'facecolor','none','edgecolor',[0.49, 0.49, 0.49]));
        %         end
        %
        %         tricontour(XY,conn,T,15)
        %         view(2)
        T=get(tempn1,'values');
        dcm=data_colormap(struct ('range',[min(T),max(T)], 'colormap',hot(9)));
        colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, T)));
        geomT=field(struct ('name', ['geomT'], ...
            'data',[get(geom,'values'), get(tempn1,'values')]));
        draw(feb, gv, struct ('x',geomT, 'u',0*geomT,...
            'colorfield',colorfield, 'shrink',1));
        draw(feb, gv, struct ('x',geom, 'u',0*geom, 'facecolor','none'));
    end
    
end

end