% INTERACTIONS BETWEEN A PARTIALLY OR TOTALLY
% IMMERSED VIBRATING CANTILEVER PLATE AND THE
% SURROUNDING FLUID
% Y. Fu AND W.G. PRICE
% Journal ofSound and Vibration (1987) 118(3), 495-513
% Table 4
% frequency 1, 2, 3, 4, 5 [Radians per second]
% 10.25, 26.4, 73.26, 87.1, 105.6
% This is the case of a square cantilever plate 1/4 submerged in
% water
neigvs = 5;
for nw=32
    nl =round(nw*1);
    rhow=1e-9;% tonne per millimeter cube
    sqplflu_dry;
    disp (['Boundary: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
    bdry_gcells = mesh_bdry(gcells, []);
    rl=[gcell_select(fens,bdry_gcells,struct ('box',[3*Length/4 Length -Inf Inf Height Height],'inflate',0.0005)),...
        gcell_select(fens,bdry_gcells,struct ('box',[3*Length/4 Length -Inf Inf 0 0],'inflate',0.0005))];
    % Uncomment the line below To select just one of the surfaces
%     rl=[gcell_select(fens,bdry_gcells,struct ('box',[-Inf Inf -Inf Inf Height Height],'inflate',0.0005))];
    bdry_gcells =subset(bdry_gcells,rl);
    
    % corners =[fenode_select(fens,struct('box',[0,0,0,0,-Inf,Inf],'inflate',0.0005)),...
    %     fenode_select(fens,struct('box',[Length,Length,0,0,-Inf,Inf],'inflate',0.0005)),...
    %     fenode_select(fens,struct('box',[Length,Length,Width,Width,-Inf,Inf],'inflate',0.0005)),...
    %     fenode_select(fens,struct('box',[0,0,Width,Width,-Inf,Inf],'inflate',0.0005))];
    % sqplflu_animation_speedy
    
    disp (['Pressure modes: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
    [W,Omega,psis] =wet_free_vibration_bem_solver(fens,bdry_gcells,W,Omega,rhow,u);
    
    disp('Wet Natural frequencies [radians per second]')
    disp(num2str(sqrt(diag(Omega)')))
    disp ([' Finished: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
end