% Rotate a mesh around a vector anchored at the given point. 
%
% function [fens] = rotate_mesh(fens, RotationVector, Point)
%
% fens= Finite element nodes of the mesh, 
% RotationVector, Point= 3-D arrays
% 
% 
function [fens] = rotate_mesh(fens, RotationVector, Point)
    R = rotmat(RotationVector);
    xyz =get(fens,'xyz');
    pivot=ones(size(xyz, 1),1)*reshape(Point,1,3);
    xyz = pivot+(R*(xyz-pivot)')';
    fens =set(fens,'xyz',xyz);
end
