% Update a box with another location, or create a new box.
% 
% function box = update_box(box,x)
% 
% box = either empty ([]), in which case a box is created using the
% supplied location, or an existing box which has expanded to include the
% supplied location x
% 
function box = update_box(box,x)
    if isempty(box)
        box=zeros(1,2*length(x));
        for i=1:length(x)
            box(2*i-1)=Inf;
            box(2*i)=-Inf;
        end
    end
    dim=length(box)/2;
    for i=1: dim
        box(2*i-1)=min(box(2*i-1),x(i));
        box(2*i)=max(box(2*i-1),x(i));
    end
end
